Program expsdehk;
Uses CRT, DOS;

Const
  GamesCount = 2;

Type
  TPatchList = Packed Record
    Offset: Array[1..GamesCount] Of Longint; { file offset: Exhumed, PowerSlave }
    Values: Array[0..1] Of Byte; { old_byte, new_byte }
  End;

  TGameList = Packed Record
    Name: String[7];  { filename }
    Game: String[11]; { gamename }
    Size: Longint;    { filesize }
  End;

  TPatches = Packed Record
    Info: String[31];       { patch description }
    Idx, Count, Stat: Byte; { index, count, state }
  End;

Const
  GameList: Array[1..GamesCount] Of TGameList = (
    (Name: 'EX.EXE'; Game: 'Exhumed';    Size: 825341),
    (Name: 'PS.EXE'; Game: 'PowerSlave'; Size: 818966)
  );
  PatchesCount = 4;
  Patches: Array[1..PatchesCount] Of TPatches = (
    (Info: 'Revert [Run] logic (always run)'; Idx:  1; Count: 1; Stat: 0),
    (Info: 'Always [Mouseview]';              Idx:  2; Count: 4; Stat: 0),
    (Info: 'Revert [Strafe] logic';           Idx:  6; Count: 4; Stat: 0),
    (Info: '/CDOFF always enabled (nocd)';    Idx: 10; Count: 2; Stat: 0)
  );
  PatchByte = 11;
  PatchList: Array[1..PatchByte] Of TPatchList = (
    { Run (7) - revert logic }
    (Offset: ($000367FE, $0003639B); Values: ($74, $75)), { always run }
    { Mouseview (25) - always on }
    (Offset: ($00036887, $00036424); Values: ($E9, $B8)), { [3] allow mouseview when Move_Forward }
    (Offset: ($000368B1, $0003644E); Values: ($E9, $BA)), { [4] allow mouseview when Move_Backward }
    (Offset: ($000368EF, $0003648C); Values: ($42, $00)), { [1] always mouseview }
    (Offset: ($00039A7E, $000395B9); Values: ($02, $00)), { [2] turn off center view }
    { Strafe (4) - revert logic (always strafe; faster than strafe left / strafe right) }
    (Offset: ($00036A81, $0003661E); Values: ($84, $85)), { [1] revert logic }
    (Offset: ($00036AA6, $00036643); Values: ($87, $57)), { [2] go to mouse_look_turn }
    (Offset: ($00036AB0, $0003664D); Values: ($21, $1C)), { [4] go to [3] }
    (Offset: ($00036ACE, $0003666B); Values: ($5F, $2F)), { [3] go to mouse_look_turn }
    { /cdoff always enabled }
    (Offset: ($000A2EC2, $000A1B8A); Values: ($00, $01)), { nocd }
    { that patch byte needed only for Exhumed - skips MSCDEX check }
    (Offset: ($0005AB77, $00000000); Values: ($75, $EB))
  );

Function FileExists(FileName: String; FileSize: Longint): Boolean;
Var DirInfo: SearchRec;
Begin
  FindFirst(FileName, ReadOnly + Hidden + SysFile + Archive, DirInfo);
  FileExists:=((DOSError = 0) And (DirInfo.Size = FileSize));
End;

Function ReadKeyEx: Word;
Var Res: Word;
Begin
  While KeyPressed Do ReadKey;
  Res:=Ord(ReadKey);
  If Res = 0 Then Res:=Word(Ord(ReadKey)) ShL 8;
  While KeyPressed Do ReadKey;
  ReadKeyEx:=Res;
End;

Procedure ShowMsgInfo(MsgStr: String);
Begin
  WriteLn(MsgStr);
  WriteLn('Press any key to exit.');
  ReadKeyEx;
End;

Procedure DrawHeader;
Begin
  ClrScr;
  WriteLn('Exhumed / PowerSlave DeHacker v1.0');
  WriteLn('(c) -=CHE@TER=- 2014');
  WriteLn('e-mail: _CTPAX_@MAIL.RU');
  WriteLn('http://CTPAX-CHEATER.losthost.org');
  WriteLn;
End;

Var
     Fl: File;
  FAttr: Word;
  FTime: Longint;
   B, I, Idx: Integer;
      X: Byte;
Begin
  DrawHeader;
  B:=0;
  For I:=1 To GamesCount Do
  Begin
    If FileExists(GameList[I].Name, GameList[I].Size) = True Then
    Begin
      B:=B Or (1 ShL (I - 1));
      WriteLn('[', I, '] ', GameList[I].Game);
    End;
  End;
  If B = 0 Then
  Begin
    ShowMsgInfo('ERROR: no game executables found! Run this program from the game folder.');
    Exit;
  End;
  Write('Select number of the game to patch (ESC - exit): ');
  Idx:=0;
  Repeat
    Idx:=ReadKeyEx;
    If Idx = 27 Then { ESC }
    Begin
      Idx:=0;
      Break;
    End;
    { only digits from 1 to 9 }
    If ((Idx > 48) And (Idx <= 48 + GamesCount)) Then Idx:=Idx - 48
    Else Idx:=0;
    { filter missing executables }
    If (B And (1 ShL (Idx - 1))) = 0 Then Idx:=0;
  Until Idx <> 0;
  If Idx = 0 Then
  Begin
    WriteLn('[exit]');
    Exit;
  End;
  WriteLn(GameList[Idx].Game);
  Assign(Fl, GameList[Idx].Name);
  GetFAttr(Fl, FAttr);
  SetFAttr(Fl, Archive);
  {$I-}
  Reset(Fl, 1);
  {$I+}
  If IOResult <> 0 Then
  Begin
    ShowMsgInfo('ERROR: can''t open file "' + GameList[Idx].Name + '" for write!');
    Exit;
  End;
  GetFTime(Fl, FTime);
  For I:=1 To PatchesCount Do
  Begin
    Seek(Fl, PatchList[Patches[I].Idx].Offset[Idx]);
    BlockRead(Fl, X, 1);
    { lazy check - only first byte in sequence for patch }
    Patches[I].Stat:=Ord(X <> PatchList[Patches[I].Idx].Values[0]); { patched? }
  End;

  Repeat
    DrawHeader;
    WriteLn('List of available patches for [', GameList[Idx].Game, ']:');
    WriteLn;
    For I:=1 To PatchesCount Do
      WriteLn('[', I,'] [', Chr(32 + Patches[I].Stat) ,'] ', Patches[I].Info);
    WriteLn;
    WriteLn('Press 1..', PatchesCount, ' for enable [!] or disable [ ] patches.');
    WriteLn('ENTER - save changes; ESC - exit without saving.');
    B:=ReadKeyEx;
    If ((B > 48) And (B <= 48 + PatchesCount)) Then
    Begin
      B:=B - 48;
      Patches[B].Stat:=(Patches[B].Stat + 1) And 1; { 0/1 }
      B:=0;
    End;
  Until (B = 13) Or (B = 27); { Enter or ESC }
  WriteLn;
  { Enter - apply patches }
  If B = 13 Then
  Begin
    Write('Exit and save changes.');
    For I:=1 To PatchesCount Do
    Begin
      For B:=1 To Patches[I].Count Do
      Begin
        { if offset = 0 - skip this byte }
        If PatchList[Patches[I].Idx + B - 1].Offset[Idx] <> 0 Then
        Begin
          Seek(Fl, PatchList[Patches[I].Idx + B - 1].Offset[Idx]);
          BlockWrite(Fl, PatchList[Patches[I].Idx + B - 1].Values[Patches[I].Stat], 1);
        End;
      End;
    End;
  End
  Else
    Write('Exit without saving.');
  SetFTime(Fl, FTime);
  Close(Fl);
  SetFAttr(Fl, FAttr);
  ShowMsgInfo('');
End.
